std::is_final(3)

NAME
std::is_final - std::is_final

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++14)
   struct is_final;
   If T is a final class (that is, a class declared with the final specifier), provides
   the member constant value equal true. For any other type, value is false.
   If T is a class type, T shall be a complete type; otherwise, the behavior is
   undefined.
   The behavior of a program that adds specializations for is_final
   or is_final_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_final_v = is_final<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a final class type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Notes
   Final classes cannot be used as base classes.
   A union can be marked final (and std::is_final will detect that), even though unions
   cannot be used as bases in any case.
   Feature-test macro: __cpp_lib_is_final

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 class A {};
 class B final {};
 int main()
 {
     std::cout
         << std::boolalpha
         << std::is_final<A>::value << '\n'
         << std::is_final<B>::value << '\n';
 }

Output:
 false
 true

See also
   is_class checks if a type is a non-union class type
   (C++11) (class template)
   is_polymorphic checks if a type is a polymorphic class type
   (C++11) (class template)